%global momorel 1
Name: grub
Version: 0.95
Release: %{momorel}m
Summary: GRUB - the Grand Unified Boot Loader.
Group: System Environment/Base
License: GPL
URL: http://www.gnu.org/software/%{name}/
Source0: ftp://alpha.gnu.org/gnu/%{name}/%{name}-%{version}.tar.gz
NoSource: 0

Source1: splash.xpm.gz

Source2: grub.conf.sakuro
Source3: grub.conf.tab
Source4: grub.conf.nyan2

#
# Patch0: grub-0.92-vga16.patch
#
# support for non-std devs (eg cciss, etc)
Patch1: grub-0.5.96.1-special-raid-devices.patch
#
# Patch5: grub-0.90-passwordprompt.patch
Patch6: grub-0.90-install.in.patch
# Patch7: grub-0.90-installcopyonly.patch
#
# link against curses statically
# Patch9: grub-0.91-staticcurses.patch
# Patch11: grub-0.91-installmktemp.patch
Patch12: grub-0.91-symlinkmenulst.patch
#
# add support for appending kernel arguments
Patch13: grub-0.90-append.patch
#Patch14: grub-0.92-libdir.patch
#Patch14: grub-0.94-libdir.patch

#rawhide patches (patch number was +100)
# let's have some sort of organization for the patches
# patches 100-119 are for config file related changes (menu.lst->grub.conf)
Patch100: grub-0.93-configfile.patch
Patch101: grub-0.90-symlinkmenulst.patch

# patch 122 is for grub-install bits
Patch122: grub-0.94-addsyncs.patch

# patches 140-159 are for miscellaneous build related patches
# compatibility for automake 1.6
# Patch141: grub-0.92-automake16.patch

# patches submitted upstream and pending approval
# change the message so that how to accept changes is clearer (#53846)
Patch181: grub-0.93-endedit.patch

# patches 200-299 are for features proposed but not accepted upstream
# add support for lilo -R-esque select a new os to boot into
Patch201: grub-0.91-bootonce.patch

# patches 300-399 are for graphics mode related patches
Patch300: grub-0.95-graphics.patch
Patch301: grub-0.91-splashimagehelp.patch
Patch302: grub-0.93-graphics-bootterm.patch
#end of rawhide patches

Patch400: grub-0.94-installcopyonly.patch

BuildPreReq: autoconf >= 2.52-8k, automake
BuildRequires: binutils >= 2.9.1.0.23, mkisofs
PreReq: info
Requires: mktemp
BuildRoot: %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: %{ix86} x86_64

%description
GRUB (Grand Unified Boot Loader) is an experimental boot loader
capable of booting into most free operating systems - Linux, FreeBSD,
NetBSD, GNU Mach, and others as well as most commercial operating
systems.

%prep
%setup -q
%patch1 -p1 -b .raid~
# %% patch5 -p1 -b .password~
%patch6 -p1 -b .install~
#%%patch7 -p1 -b .copyonly~
#%%patch9 -p1 -b .static~
# %%patch11 -p1 -b .mktemp~
%patch12 -p1 -b .menulst~
%patch13 -p1 -b .append~
#%%patch14 -p1 -b .libdir~

###
%patch100 -p1 -b .config~
%patch101 -p1 -b .menulst~

%patch122 -p1 -b .addsync~
#%%patch141 -p1 -b .automake16~
%patch181 -p0 -b .endedit~
%patch201 -p1 -b .bootonce~

%patch300 -p1 -b .graphics~
%patch301 -p1 -b .splashhelp~
%patch302 -p1 -b .bootterm~

%patch400 -p1

%build
aclocal-1.7
automake-1.7 -a
autoconf --force

%ifarch x86_64
LDFLAGS="-Wl,-static" ; export LDFLAGS
%endif
CFLAGS="-Os -g" ; export CFLAGS

%configure --sbindir=/sbin --disable-auto-linux-mem-opt
make

# --disable-auto-linux-mem-opt: don't add ``mem='' for 2.4 kernels
#Newer machines have several regions of reserved memory outside and
#inside these regions.  grub's actions are suicide on newer laptops,
#and machines like servers with lots of memory.  Laptops have special
#sections of memory above 1MB which must be reserved... Ditto for
#ACPI tables.  Using mem=XXX completely eliminates any information
#that the BIOS has provided to the OS.

dd if=/dev/zero of=grub-fd.img bs=1474560 count=1
dd if=stage1/stage1 of=grub-fd.img bs=512 count=1 conv=notrunc
dd if=stage2/stage2 of=grub-fd.img bs=512 seek=1 conv=notrunc
%__mkdir iso
%__cp -p grub-fd.img iso/
mkisofs -b grub-fd.img -o grub-cd.iso iso/

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%makeinstall sbindir=%{buildroot}/sbin
%__mkdir_p %{buildroot}/boot/grub
%__mkdir_p %{buildroot}%{_datadir}/%{name}/i386-%{_vendor}

%__install -m 644 %{SOURCE1} %{buildroot}/boot/grub
%__install -m 644 grub-fd.img grub-cd.iso %{buildroot}%{_datadir}/%{name}/i386-%{_vendor}/

%__mkdir_p %{buildroot}%{_datadir}/config-sample/%{name}/
%__ln_s %{_docdir}/%{name}-%{version}/menu.lst %{buildroot}%{_datadir}/config-sample/%{name}/grub.conf
%__install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/config-sample/%{name}/
%__install -m 644 %{SOURCE3} %{buildroot}%{_datadir}/config-sample/%{name}/
%__install -m 644 %{SOURCE4} %{buildroot}%{_datadir}/config-sample/%{name}/

# remove
%__rm -f %{buildroot}%{_infodir}/dir

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%post
if [ "$1" = 1 ]; then
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/%{name}.info.*
  /sbin/install-info --info-dir=%{_infodir} %{_infodir}/multiboot.info.*
fi

%preun
if [ "$1" = 0 ] ;then
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/%{name}.info.*
  /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/multiboot.info.*
fi

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog NEWS README COPYING TODO docs/menu.lst
%dir %{_datadir}/config-sample/%{name}
%{_datadir}/config-sample/%{name}/grub.conf*
/boot/grub
/sbin/grub
/sbin/grub-install
/sbin/grub-terminfo
/sbin/grub-md5-crypt
%{_bindir}/mbchk
%{_infodir}/%{name}*
%{_infodir}/multiboot*
%{_mandir}/man*/*
%{_datadir}/%{name}/*/*

%changelog
* Tue Jun 15 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.95-1m)
- update to 0.95
- update Patch300 grub-0.95-graphics.patch

* Thu May  6 2004 Toru Hoshina <t@momonga-linux.org>
- (0.94-7m)
- apply patch400 for anaconda.

* Sat Mar 20 2004 Toru Hoshina <t@momonga-linux.org>
- (0.94-6m)
- revised spec for enabling rpm 4.2.

* Thu Feb 05 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94-5m)
- change patch 300

* Wed Feb 04 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94-4m)
- use splash patches 300..302
- update to patch 300
- delete patch 303 was include into tarball

* Wed Jan 28 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94-3m)
- use %%{_datadir} instead of %%{_libdir}
- move grub-fd.img grub-cd.iso to %%{_datadir}/%%{name}/i386-%%{_vendor}/

* Wed Jan 28 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94-2m)
- add files %%{_datadir}/gbub/i386-*/*
- comment out Patch14: grub-0.94-libdir.patch
- use /usr/share instead of /usr/lib

* Wed Jan 28 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.94-1m)
- update to 0.94
- comment out Patch7: grub-0.90-installcopyonly.patch
- comment out Patch9: grub-0.91-staticcurses.patch
- update to Patch14: grub-0.94-libdir.patch
- update to Patch122: grub-0.94-addsyncs.patch
- comment out Patch141: grub-0.92-automake16.patch
- update to Patch300: grub-0.94-graphics.patch
- comment out Patch300: grub-0.94-graphics.patch
- comment out Patch301: grub-0.91-splashimagehelp.patch
- comment out Patch302: grub-0.93-graphics-bootterm.patch
- comment out Patch303: grub-0.93-reiserfs_journal_header.patch

* Thu Nov 13 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.93-5m)
- mv grub.conf grub.conf.sakuro in sample-config
- add grub.conf.tab to sample-config
- add grub.conf.nyan2 to sample-config
- now grub.conf is symlink to menu.lst

* Thu Oct 16 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.93-4m)
- move menu.lst from config-sample to %%doc
- add momonga grub.conf* in config-sample

* Sat Jul 12 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.93-3m)
- add grub-0.93-reiserfs_journal_header.patch

* Tue Feb 11 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.93-2m)
- update to cvs version grub-20030210
- add -n %{name} at %setup
- comment out integrated to tarball Patch182: grub-0.93-largedisk.patch
- comment out integrated to tarball Patch601: grub-0.92-hammer.patch

* Tue Feb 11 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.93-1m)
- update to 0.93
- delete duplicate ExclusiveArch: i386 i586
- add x86_64 at ExclusiveArch:
- coment out Patch0: grub-0.92-vga16.patch
- add %{_infodir}/multiboot* at files section
- add /sbin/grub-terminfo at files section
- add %{_infodir}/multiboot.info.* at post and preun section
- change CFLAGS="-ggdb" to CFLAGS="-Os -g"
- obsoleted by Patch100 Patch3: grub-0.91-configfile.patch
- integrated to taball Patch4: grub-0.90-vga16-keypressclear.patch
- comment out Patch5: grub-0.90-passwordprompt.patch
- integrated to tarball Patch15: grub-0.92-compiler-options.patch
- delete Patch120: grub-0.90-install.in.patch
- delete Patch121: grub-0.90-installcopyonly.patch
  rawhide Patch120 and Patch121 was moveing fuction place
- comment out Patch140: grub-0.90-staticcurses.patch
- delete by Patch13 Patch200: grub-0.90-append.patch
- delete by Patch1 Patch600: grub-0.93-special-device-names.patch
- comment out aclocal-old at build section
- comment out automake -a  at build section
- use aclocal-1.7 instead of aclocal-old
- use "automake-1.7 -a" instead of "automake -a"
- use "autoconf"(2.56) insted of "autoconf-old"
- add %dir at %{_datadir}/config-sample/%{name}
- merge rawhide related changelog
- comment out Patch11: grub-0.91-installmktemp.patch

* Fri Jan 17 2003 Jeremy Katz <katzj@redhat.com> 0.93-3
- add patch from HJ Lu to support large disks (#80980, #63848)
- add patch to make message when ending edit clearer (#53846)

* Sun Dec 29 2002 Jeremy Katz <katzj@redhat.com> 0.93-2
- add a patch to reset the terminal type to console before doing 'boot' from
  the command line (#61069)

* Sat Dec 28 2002 Jeremy Katz <katzj@redhat.com> 0.93-1
- update to 0.93
- update configfile patch
- graphics patch rework to fit in as a terminal type as present in 0.93
- use CFLAGS="-Os -g"
- patch configure.in to allow building if host_cpu=x86_64, include -m32 in
  CFLAGS if building on x86_64
- link glibc static on x86_64 to not require glibc32
- include multiboot info pages
- drop obsolete patches, reorder remaining patches into some semblance of order

* Sun Nov 24 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.92-11m)
- -malign-hoge is obsolete, use -falign-hoge

* Fri Nov 22 2002 OZAWA -Crouton- Sakuro <crouton@momonga-linux.org>
- (0.92-10m)
- move docs/menu.lst to config-sample.
- move architecture dependent binary modules to /usr/lib/grub.

* Thu Sep 19 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.92-9m)
- remove grub-0.5.96.1-dont-give-mem-to-kernel.patch
  added --disable-auto-linux-mem-opt to configure instead

* Wed Sep 18 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.92-8m)
- add --disable-auto-linux-mem-opt to %configure
- aclocal-old before autoconf-old

* Tue Sep 17 2002 HOSONO Hidetomo <h@h12o.org>
- (0.92-7m)
- turn "i386-redhat" to "i386-%{_vendor}"

* Thu Sep  5 2002 Jeremy Katz <katzj@redhat.com> 0.92-7
- splashscreen is in redhat-logos now

* Tue Sep  3 2002 Jeremy Katz <katzj@redhat.com> 0.92-6
- update splashscreen again

* Mon Sep  2 2002 Jeremy Katz <katzj@redhat.com> 0.92-5
- update splashscreen

* Sun Aug 25 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.92-6m)
- make grub-fd.img and grub-cd.iso for convenience

* Tue Jul 23 2002 Masahiro Takahata <takahata@momonga-linux.org>
- (0.92-5m)
- include source file

* Fri Jun 28 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.92-4m)
- momonga splash

* Sun Jun 16 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.92-4k)
- import append patch from rawhide(Patch13)

* Fri May  3 2002 Jeremy Katz <katzj@redhat.com> 0.92-2
- add patch from Grant Edwards to make vga16 + serial happier (#63491)

* Tue Apr 30 2002 Tsutomu Yasuda <tom@kondara.org>
- (0.92-2k)
  update to 0.92

* Tue Apr 30 2002 Kenta MURATA <muraken@kondara.org>
- (0.91-002001121108k)
- /sbin/install-info -> info in PreReq.

* Wed Feb 20 2002 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>    
- (0.91-002001121106k)
- add BuildPreReq: autoconf >= 2.52-8k

* Mon Jan 28 2002 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>
- (0.91-002001121104k)
- revise splash.xpm.gz
- jitterbug 1015

* Sun Dec 15 2001 Toru Hoshina <t@kondara.org>
- (0.91-0.02001121102k)
- cvs dated 2001-12-11.

* Sat Dec  8 2001 Kazuhiko <kazuhiko@fdiary.net>
- (0.90-8k)
- fix info related problem

* Tue Nov 22 2001 TABUCHI Takaaki <tab@kondara.org>
- (0.90-6k)
- add patch grub-jfs_xfs-1.0.tar.bz2
- but don't use patch, because this patch is include in grub-0.91 (from cvs)

* Wed Nov 21 2001 Mitsuru Shimamura <mitsuru@diana.dti.ne.jp>
- (0.90-6k)
- change "URL"

* Sat Oct 27 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (grub 0.90-4k)
- from rawhide
- new Kondara splash
- merge old SPEC (grub-0.90-2k)

* Wed Sep  5 2001 Jeremy Katz <katzj@redhat.com>
- grub-install: if /boot/grub/grub.conf doesn't exist but /boot/grub/menu.lst 
  does, create a symlink

* Fri Aug 24 2001 Jeremy Katz <katzj@redhat.com>
- pull in patch from upstream CVS to fix md5crypt in grub shell (#52220)
- use mktemp in grub-install to avoid tmp races

* Fri Aug  3 2001 Jeremy Katz <katzj@redhat.com>
- link curses statically (#49519)

* Thu Aug  2 2001 Jeremy Katz <katzj@redhat.com>
- fix segfault with using the serial device before initialization (#50219)

* Thu Jul 19 2001 Jeremy Katz <katzj@redhat.com>
- add --copy-only flag to grub-install

* Thu Jul 19 2001 Jeremy Katz <katzj@redhat.com>
- copy files in grub-install prior to device probe

* Thu Jul 19 2001 Jeremy Katz <katzj@redhat.com>
- original images don't go in /boot and then grub-install does the right
  thing

* Thu Jul 19 2001 Jeremy Katz <katzj@redhat.com>
- fix the previous patch
- put the password prompt in the proper location

* Thu Jul 19 2001 Jeremy Katz <katzj@redhat.com>
- reset the screen when the countdown is cancelled so text will disappear 
  in vga16 mode

* Mon Jul 16 2001 Jeremy Katz <katzj@redhat.com>
- change configfile defaults to grub.conf

* Sun Jul 15 2001 Jeremy Katz <katzj@redhat.com>
- updated to grub 0.90 final

* Fri Jul  6 2001 Matt Wilson <msw@redhat.com>
- modifed splash screen to a nice shade of blue

* Tue Jul  3 2001 Matt Wilson <msw@redhat.com>
- added a first cut at a splash screen

* Sun Jul  1 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix datadir mismatch between build and install phases

* Mon Jun 25 2001 Jeremy Katz <katzj@redhat.com>
- update to current CVS 
- forward port VGA16 patch from Paulo Csar Pereira de 
  Andrade <pcpa@conectiva.com.br>
- add patch for cciss, ida, and rd raid controllers
- don't pass mem= to the kernel

* Wed May 23 2001 Erik Troan <ewt@redhat.com>
- initial build for Red Hat
